/* BladeEnc prefs editor and small GUI for encoding by Andrea Vallinotto with
   fixes by Martin 'Helios' Steigerwald (AKA "Riser forest" :-)) ).
$VER: BladeEnc.rexx 1.1 (28.2.01)
*/

options results

call setuplib("rexxreqtools.library",0,-30,0)

cfgfilename='BladeEnc.cfg'

oldcfg=readcfgfile(cfgfilename) /* empty if file not found or empty */

if oldconfig == '' then noconfig = 1
			else noconfig = 0

basecmd = "BladeEnc" /* Name of the executable! */

disstring = 'DISABLED'
cr='0a'x

use_opts_names=0

options failat 21
address command "version >NIL:" basecmd "1 2"
options failat 20

select
	when rc=5 then canbatch=0
	when rc=0 then canbatch=1
	otherwise do
			say "The needed executable ("basecmd") was not found ! Aborting..."
			exit(20)
			end
end


/* Type can be: Boolean, Number, Directory, Range */
i=1

opts.i.type='N'
opts.i.string='' /* */
opts.i.values='32 40 48 56 64 80 96 112 128 160 192 224 256 320'
opts.i.dizcrypt='MP3 bitate in Kbit'
opts.i.alias='-br '
opts.i.default='192'

i=i+1
opts.i.type='D'
opts.i.string='outdir=' /* */
opts.i.values=''
opts.i.dizcrypt='output (MP3) directory'
opts.i.alias=''
opts.i.default=disstring

i=i+1
opts.i.type='B'
opts.i.string='sort'
opts.i.dizcrypt='sort jobs on input queue.'
opts.i.alias=''
opts.i.default=disstring

i=i+1
opts.i.type='R'
opts.i.string='prio='
opts.i.max='127'
opts.i.min='-128'
opts.i.dizcrypt='program priority for WarpOS'
opts.i.alias=''
opts.i.default='0'

i=i+1
opts.i.type='B'
opts.i.string='quiet'
opts.i.dizcrypt='disable screen output.'
opts.i.alias=''
opts.i.default=disstring

i=i+1
opts.i.type='R'
opts.i.string='progress='
opts.i.max='8'
opts.i.min='0'
opts.i.dizcrypt='type of progress indicator (0=disabled)'
opts.i.alias=''
opts.i.default='0'

i=i+1
opts.i.type='R'
opts.i.string='refresh='
opts.i.max='4'
opts.i.min='1'
opts.i.dizcrypt='Refresh rate for progress indicator. 1=fastest, 4=def'
opts.i.alias=''
opts.i.default=disstring

i=i+1
opts.i.type='B'
opts.i.string='sort'
opts.i.dizcrypt='Sort jobs on input name'
opts.i.alias=''
opts.i.default=disstring

i=i+1
opts.i.type='B'
opts.i.string='crc'
opts.i.dizcrypt='Include checksum data in MP3 file'
opts.i.alias=''
opts.i.default='1'

i=i+1
opts.i.type='B'
opts.i.string='delete'
opts.i.dizcrypt='delete original sample file'
opts.i.alias='del'
opts.i.default=disstring

i=i+1
opts.i.type='B'
opts.i.string='private'
opts.i.dizcrypt='Set the private-flag in the output file(s)'
opts.i.alias='p'
opts.i.default=disstring

i=i+1
opts.i.type='B'
opts.i.string='copyright'
opts.i.dizcrypt='Set the copyright-flag in the output file'
opts.i.alias='c'
opts.i.default=disstring

i=i+1
opts.i.type='B'
opts.i.string='swap'
opts.i.dizcrypt='Swap left and right stereo channels'
opts.i.alias=''
opts.i.default=disstring

i=i+1
opts.i.type='B'
opts.i.string='nogap'
opts.i.dizcrypt="Make sure there's no gap between tracks"
opts.i.alias=''
opts.i.default=disstring


opts.0=i /* Total of options/switches */

do i=1 to opts.0
	opts.i.actual = disstring
end

/* Parses old configuration file */

if ~noconfig then do i=1 to opts.0
			otype=opts.i.type

			select
				when otype='R' then if fillval(i oldcfg) then oldcfg=stripopt(i oldcfg)
				when otype='B' then if find(oldcfg, '-'opts.i.string) then do
										opts.i.actual=1
										oldcfg = stripopt(i oldcfg)
										end
										else opts.i.actual=opts.i.default
				when otype='D' then if fillpath(i oldcfg) then oldcfg=stripopt(i oldcfg)
				when otype='N' then if fillval(i oldcfg) then oldcfg=stripopt(i oldcfg)
				otherwise call very_bad_exit sigl
			end

		end

do i = 1 to opts.0
	if (opts.i.actual == disstring & opts.i.default ~='') then opts.i.actual=opts.i.default
end

oldcfg=strip(oldcfg)

/* Main options right now:
1) Configure
2) Save config and encode
3) Do not save config and encode (config->commandline)
4) Encode only
0) Abort
*/

cfgreqtext=''

do i = 1 to opts.0
	if ~use_opts_names then cfgreqtext = cfgreqtext||i'= '
	cfgreqtext=cfgreqtext '-'left(opts.i.string, 15) '('opts.i.type')' opts.i.dizcrypt||cr
	end

cmdline=basecmd

mainreqchoice="_Configure|_Save this configuration & encode|_Use this configuration & encode|Use _default configation & encode|_Abort"

/* Builds up configuration requester text */
choicestr=''

if use_opts_names then do i = 1 to opts.0
	choicestr = choicestr'|'opts.i.string
	end
else do i = 1 to opts.0
	choicestr = choicestr'|'i
	end

choicestr = right(choicestr, length(choicestr)-1)'|Return'

/* say choicestr */

mainloop:

mainreqtext=strip(dumpconfig()' 'oldcfg)

choice=rtezrequest('Select operation'cr'Loaded configuration is:'mainreqtext, mainreqchoice, "BladeEnc rexx tool main menu",'rtez_defaultresponse = 4')

if choice ~= 0 then select
			when choice=1 then signal configureloop
			when choice=2 then signal savec
			when choice=3 then signal useconfig
			when choice=4 then signal encode
			otherwise exit 0
		end
else exit 0

configureloop:

ans=rtezrequest("Select number corresponding to option to change"||cr||cfgreqtext, choicestr, 'Change which option ?','rtez_defaultresponse = 0')

if(ans ~= 0) then do
			select
				when opts.ans.type = 'D' then call choosedir ans
				when opts.ans.type = 'R' then call chooserange ans
				when opts.ans.type = 'N' then call choosenumber ans
				when opts.ans.type = 'B' then call chooseboolean ans
				otherwise signal very_bad_exit			
			end
			/*say dumpconfig()*/
			signal configureloop

		end
else signal mainloop

savec:
config=strip(dumpconfig()) oldcfg
if(open(fh, cfgfilename, 'W')) then do
				call WriteLN(fh, config)
				call Close(fh)
				end

signal encode

useconfig:
cmdline=cmdline strip(dumpconfig()) oldcfg


encode:
call rtfreefilebuffer()

if canbatch then flagstring='rtfi_flags = freqf_multiselect'
else flagstring=''

newname = rtfilerequest(,,'Select files to encode',"_Encode!",flagstring,files)

if (files.count == "FILES.COUNT" & newname = '') then signal on_final

if (newname ~= '') then do
			cmdline = cmdline '"'newname'"'
			if canbatch then files.count = files.count-1
					else files.count =0
			end

if (files.count > 0) then do i = 1 to files.count
				cmdline=cmdline '"'files.i'"'
			end

on_final:
/*say cmdline*/

call pragma(s, 30000) /* Set stack, quite big for WarpOS programs */
address command cmdline


if RC ~= 0 then say "An error occurred! Check you input names and program installation"

exit RC

/* Support procedures */

stripopt: procedure expose opts.
parse arg i oldcfg

oldcfg=strip(oldcfg)

if opts.i.type ~= 'B' then takemeout='-'opts.i.string||opts.i.actual
else takemeout='-'opts.i.string

return delword(oldcfg, find(oldcfg, takemeout), 1)

/*--------------------------------------------*/

fillpath: procedure expose opts.
parse arg st line

optbegin=pos('-'opts.st.string, line)
optlen=length(opts.st.string)
if optbegin == 0 then if opts.st.alias ~= '' then do
						optbegin = pos('-'opts.st.alias, line)
						optlen = length(opts.st.alias)
						end

if optbegin ~= 0 then do
		sub=right(line, length(line)-optbegin-optlen)
		parse var sub value .
		if isapath(value) then do 
					opts.st.actual=value
					return 1
					end
		end
else opts.st.actual=opts.st.default

return 0
/*---------------------------------------------*/
fillval: procedure expose opts.
parse arg st line

/*say "filling against" opts.st.string*/

optbegin=pos('-'opts.st.string, line)
optlen=length(opts.st.string)
if optbegin == 0 then if opts.st.alias ~= '' then do
						optbegin = pos('-'opts.st.alias, line)
						optlen = length(opts.st.alias)
						end
if optbegin ~= 0 then do
		sub=right(line, length(line)-optbegin-optlen)
		parse var sub value .
		if value ~= '' & datatype(value, 'W') then do 
							opts.st.actual=value
							return 1
							end
		end
else opts.st.actual=opts.st.default

return 0


/*--------------------------------------*/

saveentry: procedure expose opts.
parse arg st file

if opts.st.actual ~= disstring then if(opts.st.type = 'B') then call write(file, " "||opts.st.string)
							else call write(file, " "||opts.st.string||opts.st.actual)

return

/*---------------------------------------------------------------------------*/


chooseboolean: procedure expose opts. disstring
parse arg st

defresponse=opts.st.default

if defresponse == disstring  then defresponse = 0

if ~rtezrequest('Do you want to' opts.st.dizcrypt,'_Yes|_No',"Setting option for '"opts.st.string"'",'rtez_defaultresponse = 'defresponse,) then opts.st.actual=0
else opts.st.actual=1

/*say opts.st.string opts.st.actual */

return

/*---------------------------------------------------------------------------*/
choosenumber: procedure expose opts. disstring
parse arg st

/* Processing values string */
nopts=words(opts.st.values)
defpos=find(opts.st.values, opts.st.default)

if defpos ~= 0 then if defpos = nopts then defresponse=0
			else defresponse = defpos

valstring=word(opts.st.values,1) /* First argument */

do i=2 to nopts
		valstring = valstring||'|'||word(opts.st.values, i)
		end

retval=rtezrequest('Choose value for' opts.st.dizcrypt, valstring, "Setting option for '"opts.st.string"'",'rtez_defaultresponse = 'defresponse,)

if retval == 0 then retval = nopts

opts.st.actual = word(opts.st.values, retval)

return

/*---------------------------------------------------------------------------*/
choosedir: preocedure expose opts. disstring
parse arg st

defresponse = opts.st.default

if defresponse = disstring then defresponse = ''

dir = rtfilerequest(defresponse,,'Select' opts.st.dizcrypt,,'rtfi_flags = freqf_nofiles')

/* say dir */

if dir = '' then return
else opts.st.actual=dir

return

/*---------------------------------------------------------------------------*/

chooserange: procedure expose opts. disstring
parse arg st

defval = opts.st.default

if defval == disstring then defval = 0 /* Hummm.... */

val=rtgetlong(defval, "Choose value for" opts.st.dizcrypt, "Setting option for '"opts.st.string"'",,'rtgl_max='opts.st.max 'rtgl_min='opts.st.min)

if(val ~= '') then opts.st.actual= val

return


/*---------------------------------------------------------------------------*/

readcfgfile: procedure
outstring=''

if open(in, arg(1), 'R') then do
		do until (eof(in) & length(outstring) < 256)
			outstring=outstring readln(in)
			end
		outstring=strip(outstring)
		call close(in)
		end

return outstring

/*--*/

dumpconfig: procedure expose opts.

retvar=''
do i = 1 to opts.0

	if (opts.i.type = 'B' & opts.i.actual==1) then retvar=retvar '-'opts.i.string
	else if opts.i.actual ~= "DISABLED" then retvar=retvar '-'opts.i.string||opts.i.actual

end

return retvar

/*---*/

isapath: procedure
parse arg pathin
if datatype(pathin, A) then return 1
if verify(pathin, ' !"$'||xrange('+','>')||xrange('@','{')||"}") == 0 then return 1

return 0

/*--*/

setuplib: procedure
parse arg library,v1,v2,v3

if(~show('l',library))then	do
				if(~addlib(library,v1,v2,v3))then	do
									say "Could not open" library"! Aborting..."
									call exit 10
									end
				end
return 1

very_bad_exit: procedure

say "Internal error at line" arg(1)
exit(20)
